"""
	Flow networks
"""
class net_arc:
	def __init__(self, tail, head, rev, cap):
		self.tail, self.head = tail, head	# tail -> head
		self.rev = rev						# reverse arc index in head's incidence list
		self.f, self.cap = 0, cap			# flow & capacity

# A flow network is a list of lists of net_arcs

class flow_network(list): 
	def __init__(G, n): 
		"Return the empty graph on nodes 0..n-1"
		G.extend([[] for _ in range(n)])

	def add_arc(G, u, v, cap): 
		rcap = 0
		"""Add to G a directed arc (u,v) of capacity cap
		and a reverse arc (v,u) of capacity rcap"""
		uv_pos = len(G[u])
		vu_pos = len(G[v])
		G[u].append( net_arc(u,v,vu_pos,cap) )
		G[v].append( net_arc(v,u,uv_pos,rcap) ) # reverse arc
